import logging
import os
import sys

import tempfile

from . import TestCase

from mc308.data_structures.nba import NBA, GNBA
from mc308.data_structures.repr_nba import nba_to_dot

from pysmt.shortcuts import Symbol, TRUE, get_env


class TestGNBA(TestCase):
    def test_degeneralize(self):
        get_env().enable_infix_notation = True

        gnbas = [
            # Example  from class
            GNBA(set([0,1,2]),
                 set(["green,red"]),
                 [(0,TRUE(),0),
                  (0,Symbol("red"),1),
                  (0,Symbol("green"),2),
                  (1,TRUE(),0),
                  (2,TRUE(),0)
                ],
                 set([0]),
                 set([frozenset([1]),frozenset([2])])
                 ),
            GNBA(set([0,1,2]),
                 set(["green,red"]),
                 [(0,TRUE(),0),
                  (0,Symbol("red"),1),
                  (0,Symbol("green"),2),
                  (1,TRUE(),0),
                  (2,TRUE(),0)
                ],
                 set([0]),
                 set([]) # special case
                 ),
            GNBA(set([0,1,2]),
                 set(["green,red"]),
                 [(0,TRUE(),0),
                  (0,Symbol("red"),1),
                  (0,Symbol("green"),2),
                  (1,TRUE(),0),
                  (2,TRUE(),0)
                ],
                 set([0]),
                 set()
                 ),
        ]

        for G in gnbas:
            print(nba_to_dot(G))
            print(G.final)

            nba = G.to_nba()
            nba_to_dot(nba)
